var alpha = ["A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z","AA","AB","AC","AD"];
var sectionmaster = {
  "0" : {
          "count" : 0,
          "activeSlide" : 0
        }
}

$(document).ready(function () {
    
        
   
    var masterExerciseList = {
      "Burpee" : {"tags" : ['core']},
      "Front Squat" : {"tags" : ['push', 'push-child', 'push-child-2', 'push-sub-child', 'pull', 'pull-child', 'pull-child-2', 'pull-sub-child-2', 'pull-sub-child', 'legs', 'sholders', 'core']},
      "Air Squat" : {"tags" : ['push', 'push-child-2', 'push-sub-child']},
      "Back Squat" : {"tags" : ['pull', 'pull-child', 'pull-child-2', 'pull-sub-child-2']},
      "Jump Squat" : {"tags" : ['pull', 'pull-child', 'pull-child-2', 'pull-sub-child']},
      "Sumo Squat" : {"tags" : ['legs', 'sholders', 'core']},
      "Deadlift" : {"tags" : ['sholders', 'core']},
    }

    

    var coachExerciseList = {
      "My Front Squat" : {"tags" : ['legs', 'sholders', 'core']},
      "My Air Squat" : {"tags" : ['push', 'push-child-2', 'push-sub-child']},
      "My Back Squat" : {"tags" : ['pull', 'pull-child', 'pull-child-2', 'pull-sub-child-2']},
      "My Jump Squat" : {"tags" : ['pull', 'pull-child', 'pull-child-2', 'pull-sub-child']},
      "My Sumo Squat" : {"tags" : ['legs', 'sholders', 'core', 'push']},
      "My Deadlift" : {"tags" : ['sholders', 'core']},
      "My Burpee" : {"tags" : ['core']},
    }

    // $(document).on("click",".tagBox > li", function () {
    //     console.log($(this).find("ul").html());
    //     $(this).next("ul").show();
    // })
    
    $(document).on("click",(".clearTag"),function(){
      // console.log("clear tag",$(this).closest(".clear-tags-box").html());
      $(this).closest(".clear-tags-box").find('input[type="checkbox"]').each(function() {
        $(this).removeClass("active");
        if(this.checked){
          this.checked = false;
        }
        arr = [];
      });

      updateExerciseList(arr,$(this),needToCheck=false);

      $(this).closest(".clear-tags-box").find('.childClass').removeClass("active");
      $(this).closest(".clear-tags-box").find('.superChildClass').removeClass("active");

      $(this).closest(".leftlabels").find(".exerciseName").trigger("keyup");

      // $(this).closest(".tagBox").find('input[type="checkbox"]').each(function() {
      //   this.checked = false;
      // });
    })

    $(document).on("change",(".intensityPaceBoxSelect"),async function(){
      let minute = $(this).closest(".intensitySelection").find(".intensityPaceBoxTimeMinute").val();
      let second = $(this).closest(".intensitySelection").find(".intensityPaceBoxTimeSecond").val();
      let distance = $(this).closest(".intensitySelection").find(".intensityPaceBoxTimeDistance").val();
      let newValue = minute+"Min"+second+"s / "+distance+"M";
      $(this).closest(".intensitySelection").find(".intensityPaceBoxTime").text(newValue);
      jQuery(this).closest(".mainSectionStart").find(".copyFirst").val("no").change();
      await updatePreview();
    })

    async function updatePreview(){
      $("#sessionPreview").html('');
      let sessionName = $("#sessionTitle").val(); 
      sessionName = sessionName?sessionName:'Session Title';
      let headerOfPreview = '<div class="workout-title"><h2 id="sessionTitleInPreview">'+sessionName+'</h2></div>';
      let section = "";
      $(document).find(".main-content-section").find(".sectionStart").each(function(index, item) {
        // $(this).html('');
        section += '<div class="inner-data-wrap">';
        section += '<h3> '+$(this).find('.sectionTitle').html()+' </h3>';
        section += '<ul>';
        
        // $(this).find('.form-block').each(function(index,item){
        //   section += '<li><span>'+$(this).find(".leftlabels:first").find(".title-top").html()+'</span>';
        //   section += '</li>';
        // })

        $(this).find('.item-block').each(function(index,item){

          // $('.selectdrop').select2();
          
          // console.log($(this).find(".leftlabels:nth-child(2)").find(".quantitySelectField").html());
          
          let quantityType = $(this).find(".leftlabels:nth-child(2)").find(".quantitySelectField").val();
          let intensityType = $(this).find(".leftlabels:nth-child(2)").find(".intensityChange").val();

          let              ="";
          if(quantityType=="reps")
          quantityTypeSelection = $(this).find(".leftlabels:nth-child(2)").find(".selectionReps > .quantitySelector").val();

          if(quantityType=="distance"){
            quantityTypeSelection = $(this).find(".leftlabels:nth-child(2)").find(".selectionDistance > .quantitySelector").val();
            quantityTypeSelection = quantityTypeSelection?quantityTypeSelection:0;
            quantityTypeSelection = quantityTypeSelection + "M";
          }
          if(quantityType=="time"){
            // quantityTypeSelection = $(this).find(".leftlabels:nth-child(2)").find(".selectionTime > .quantitySelector").val();
            let minutes = $(this).find(".leftlabels:nth-child(2)").find(".selectionTime > div > .minutes").val();
            let seconds = $(this).find(".leftlabels:nth-child(2)").find(".selectionTime > div > .seconds").val();
            quantityTypeSelection = minutes+"Min"+seconds+"Sec";
          }
          if(quantityType=="cals")
          quantityTypeSelection = $(this).find(".leftlabels:nth-child(2)").find(".selectionCals > .quantitySelector").val();
          
          // console.log("quantityType",quantityType);
          // console.log("intensityType",intensityType);

          let intensityTypeSelection = "";
          if(intensityType=="percentage")
          intensityTypeSelection = $(this).find(".leftlabels:nth-child(2)").find(".intensityPercentage > .intensitySelector").val();
        
          if(intensityType=="rir")
          intensityTypeSelection = $(this).find(".leftlabels:nth-child(2)").find(".intensityRir > .intensitySelector").val();
        
          if(intensityType=="rpe")
          intensityTypeSelection = $(this).find(".leftlabels:nth-child(2)").find(".intensityRpe > .intensitySelector").val();
        
          if(intensityType=="pace"){
            intensityTypeSelection = $(this).find(".leftlabels:nth-child(2)").find(".intensityPace > .intensityPaceBoxTime").text();
          }
          if(intensityType=="zone")
          intensityTypeSelection = $(this).find(".leftlabels:nth-child(2)").find(".intensityZone > .intensitySelector").val();
      
          
          let exerciseName = $(this).find(".leftlabels:nth-child(2)").find(".exerciseName").val();
          section += '<li><div>'+$(this).parent().find(".form-block").find(".numberofSet").val()+' Sets</div>';
          section += '<li><span>'+$(this).find(".leftlabels:first").find(".title-top").html()+'</span><div>'+quantityTypeSelection+' '+exerciseName+' '+intensityTypeSelection+'</div>';
          section += '</li>';

        })
        // section += '<div> 10 Half Kneeling Hip Shift</div>';
        section += '</ul>';
        section += '</div>';
      });
      $("#sessionPreview").append(headerOfPreview );
      $("#sessionPreview").append(section );

    }

    jQuery(document).on("change",".intensityChange",function(){
      let intensityValue = $(this).val();
      $(this).closest("li").find(".intensitySelection").hide();
      if(intensityValue == "percentage"){
        $(this).closest("li").find(".intensityPercentage").show();
      }else if(intensityValue == "rir"){
        $(this).closest("li").find(".intensityRir").show();
      }else if(intensityValue == "rpe"){
        $(this).closest("li").find(".intensityRpe").show();
      }else if(intensityValue == "pace"){
        $(this).closest("li").find(".intensityPace").show();
      }else if(intensityValue == "zone"){
        $(this).closest("li").find(".intensityZone").show();
      }
      
    })  
    //
    jQuery(document).on("change",".quantitySelectField",function(){
      let quantityVal = $(this).val();
      // console.log($(this).closest("li").find(".quantitySelection").html());
      // $(this).closest("li").find(".select2-selection").hide();
      // $(this).closest("li").find(".quantitySelection").select2().hide();
      $(this).closest("li").find(".quantitySelection").hide();
      // $(this).closest("li").find(".quantitySelection").select2().hide();

      if(quantityVal =='reps'){
        $(this).closest("li").find(".selectionReps").show();
      }else if(quantityVal =='distance'){
        $(this).closest("li").find(".selectionDistance").show();
        
      }else if(quantityVal =='time'){
        $(this).closest("li").find(".selectionTime").show();
      }else{
        $(this).closest("li").find(".selectionCals").show();
      }
    })



    jQuery(document).on("click",".deleteSection", async function(){
      $(this).closest(".sectionStart").remove();
      
      await updatePreview();
    })
    
    //Add new section
    jQuery("#sessionTitleUpdate").on("click",async function(){
      $("#sessionPlannerHeader").html($("#sessionTitle").val());
      $(".setmodal").modal('hide');
      await updatePreview();
      methods();
    })

    //Add new section
    jQuery(".sectionAdd").on("click", async function(e){
      

      e.preventDefault();
      var sectionLength = $(".sectionStart").last().attr('data-id');
      sectionLength = parseInt(sectionLength)+1;
      $(document).find(".sectionStart").last().after(newSectionAdd(sectionLength));
      // setsCarousel();
      sectionmaster[sectionLength] = {
        "count" : 0, "activeSlide" : 0
      }
      setsCarousel();
      await updatePreview();
      $('.selectdrop').select2();
      // console.log("sectionmaster",sectionmaster);
    })

    async function updateCopyFirstToNo(){
      $(document).on("change",".leftlabels select", async function(){
        // console.log("in");
        jQuery(this).closest(".mainSectionStart").find(".copyFirst").val("no").change();
        await updatePreview();
      });
      $(document).on("keyup",".leftlabels input[type=text]", async function(){
        jQuery(this).closest(".mainSectionStart").find(".copyFirst").val("no").change();
        await updatePreview();
      });
      // console.log("sectionmaster",sectionmaster);
      await updatePreview();
    }
    
    updateCopyFirstToNo();

    jQuery(document).on("click",".sectionName ul li", async function(){
        jQuery(this).closest(".sectionStart").find(".sectionTitle").text(jQuery(this).find("span").text());
        jQuery(this).closest(".sectionStart").find(".sectionImage img:first").attr("src",jQuery(this).find(".icon-wrx img").attr("src"));
        // jQuery(this).closest(".sectionStart").find(".sectionImage img:first").attr("src",jQuery(this).find(".icon-wrx img").attr("src"));
        jQuery(this).parents(".sectionName").addClass("d-none");
        await updatePreview();
        jQuery(this).closest(".mainSectionStart").find(".copyFirst").val("no").change();
        
    })

    $ (document).find(".selectdrop").on("click", function (params) {
      $(".select2-dropdown--below").addClass("active");
    });


    $(document).on("click",".exerciseList ul > li", async function (params) {
        $(".exerciseName").removeClass('active');
        $(this).closest(".exerciseBoxParent").find(".exerciseName").val($(this).text().trim());
        $(this).closest(".Squats-drop-recorded").hide();
        await updatePreview();
    })
    var arr= [];
    $(document).on("click",".exerciseName", async function (params) {
        // Squats-drop-recorded
        if($(this).hasClass("active")){
          return false;
        }
        
        $(".exerciseName").removeClass('active');
        $(".Squats-drop-recorded").html('');
        $(".Squats-drop-recorded").hide();
        $(this).addClass('active');
        // $(".Squats-drop-recorded").html(exerciseSerch());
        $(this).closest(".leftlabels").find(".Squats-drop-recorded").show();
        $(this).closest(".leftlabels").find(".Squats-drop-recorded").html(exerciseSerch());

        

        updateExerciseList(arr,$(this),needToCheck=false);

        // console.log($(this).closest(".leftlabels").find(".Squats-drop-recorded").find(".exerciseGet.active").html());
        // $(this).closest(".leftlabels").find(".Squats-drop-recorded").find(".exerciseBox").find(".exerciseGet:first").trigger("click");

        // $(this).closest(".leftlabels").find(".Squats-drop-recorded").toggle();

        var searchText = $(this).val().toLowerCase();
        // console.log("searchText",searchText);
        
        $(this).closest(".leftlabels").find(".exerciseBox ul > li").each(function(){
            var currentLiText = $(this).text().toLowerCase(),
                showCurrentLi = currentLiText.indexOf(searchText) !== -1;
            $(this).toggle(showCurrentLi);
        });    

        $(this).closest(".leftlabels").find(".exerciseName").keyup(function exerciseKeyUp(){
            var searchText = $(this).val().toLowerCase();
            // console.log("searchText",searchText);
            var a = 1;
            $(this).closest(".leftlabels").find(".exerciseBox ul > li").each(function(){
                var currentLiText = $(this).text().toLowerCase(),
                    showCurrentLi = currentLiText.indexOf(searchText) !== -1;
                    if(showCurrentLi){
                      a=2;
                    }
                    // console.log("showCurrentLi",showCurrentLi);
                $(this).toggle(showCurrentLi);
            });  
            
            if(a==1){
              $(this).closest(".leftlabels").find(".exerciseBox ul").hide(); 
              $(this).closest(".leftlabels").find(".exerciseBox .noRecords").show();
            }else{
              $(this).closest(".leftlabels").find(".exerciseBox ul").show(); 
              $(this).closest(".leftlabels").find(".exerciseBox .noRecords").hide();
            }
        });
        $(this).closest(".leftlabels").find(".exerciseName").trigger("keyup");
        
        $(document).on("click",".tagCheckBox",async function(){
          $(this).toggleClass("active");
          let checkedValue = $(this).val();
          if(jQuery.inArray(checkedValue, arr) == -1){
            arr.push(checkedValue);
          }else{
            arr = arr.filter(function(arrVal) {
                return arrVal !== checkedValue
            })
          }
          
          // console.log("checkedValue",checkedValue);
          if($(this).hasClass("active") && $(this).hasClass("firstLevelCheckBox")){
            $(this).parent().find("ul:first").addClass("active");
          }

          if($(this).hasClass("active") == false && $(this).hasClass("firstLevelCheckBox")){
            $(this).parent().find("ul:first").removeClass("active");
            $(this).parent().find(".active").removeClass("active");
            $(this).parent().find('input[type="checkbox"]').each(function() {
              if(this.checked){
                let v = $(this).val();
                arr = arr.filter(function(arrVal) {
                  // console.log("value",v)
                    return arrVal !== v
                })
                this.checked = false;
              }
            })


            

          }

          if($(this).hasClass("active") && $(this).hasClass("secondLevelCheckBox")){
            $(this).parent().find("ul:first").addClass("active");
          }

          if($(this).hasClass("active") == false && $(this).hasClass("secondLevelCheckBox")){
            $(this).parent().find("ul:first").removeClass("active");
            $(this).parent().find("ul").find('input[type="checkbox"]').each(function() {
              if(this.checked){
                let v = $(this).val();
                arr = arr.filter(function(arrVal) {
                  // console.log("value",v)
                    return arrVal !== v
                })
                this.checked = false;
              }
            })
          }

          // console.log(arr);
          // console.log(masterExerciseList);
          let isAllUnchecked = true;
          $(this).closest(".tagBox").find(".firstLevelCheckBox").each(function(){
            if(this.checked){
              isAllUnchecked = false;
              // console.log("checked");
            }else{
              // console.log("unchecked");
            }
          })
          
          if(isAllUnchecked){
            updateExerciseList(arr,$(this),needToCheck=false);
          }else{
            updateExerciseList(arr,$(this),needToCheck=true);
          }
         
        })
        await updatePreview();
        
    });


    function updateExerciseList(arr,thisRec,needToCheck){
      var excrcises = [];
      let exerciseHtml = "";
      let finalList = coachExerciseList;
      if(thisRec.closest(".exerciseBoxParent").find(".exerciseGet.active").attr("data-type") == "defaultLibrary"){
        finalList = masterExerciseList;
      }
      $.each(finalList, function(key,valueObj){
        if("tags" in valueObj &&  valueObj.tags.length > 0){
          let tags  = valueObj.tags;
          $.each( tags, function( i, val ) {
            if(needToCheck){
              // console.log("need to check");
              if($.inArray(val.trim(), arr)  != -1){
                excrcises.push(key); //= key;
                exerciseHtml += "<li>"+key+"</li>";
                return false;
              }
            }else{
              // console.log("key",key);
              exerciseHtml += "<li>"+key+"</li>";
              return false;
            }
          });
        }
        // console.log( finalList);
      });
      
      thisRec.closest(".exerciseBoxParent").find(".exerciseList > ul").html(exerciseHtml);

      // console.log(excrcises);
    }

    $(document).on("click", function (e) {
        let container = $(".Squats-dropdown-listing");
        if (!container.is(e.target) && container.has(e.target).length === 0) {
            $(".exerciseName").removeClass('active');
            $(".Squats-drop-recorded").hide();
        }
    });

    $(document).on("click",".intensityPaceBoxTime", function () {
      $(".intensityPaceBox-outer").hide();
      $(this).parent().find(".intensityPaceBox-outer").toggle();
    })
    $(document).on("click", function (e) {
      let container = $(".intensityPaceBoxTime,.intensityPaceBox-outer");
      // console.log("container.has(e.target).length ",container.has(e.target).length );

        if (!container.is(e.target) && container.has(e.target).length === 0) {
          
            // console.log("Zero");
            $(".intensityPaceBox-outer").hide();
          }
    });
    
    $(document).on("change",".copyFirst",function(){  

      
      // copyFirst
      if($(this).val() == 'yes'){
          $('.selectdrop').select2("destroy");
          $('.selectdrop-warmup').select2("destroy");
          let patternName = $(this).closest(".pattern-blocks").find(".selectPattern").val();
          let numberOfSet = $(this).closest(".pattern-blocks").find(".owl-item.active").find('.numberofSet').val();
          for (let index = 0; index < numberOfSet-1; index++) {
              $(this).closest(".pattern-blocks").find(".owl-item.active").find('.item-block').find(".leftlabels").last().remove();;
          }
          for (let index = 1; index < numberOfSet; index++) {
              if(patternName == "strength"){
                let $orginal = $(this).closest(".pattern-blocks").find(".owl-item.active").find('.item-block').find(".leftlabels:nth-child(2)");
                let $cloned = $orginal.clone();
                var $originalSelects = $orginal.find('select');
                $cloned.find('select').each(function(index, item) {
                    //set new select to value of old select
                    $(item).val( $originalSelects.eq(index).val() );
                
                });
                $cloned.find(".title-top").html("Set "+(parseInt(index)+1));
                let liOfList = $cloned.find(".sets-list:first").find("li:first");
                liOfList.html("");
                liOfList.css("height", "35px");

                // $cloned.find(".exerciseName").val("");
                // $cloned.find(".exerciseName").attr("disabled","disabled");
                $cloned.appendTo($(this).closest(".pattern-blocks").find(".owl-item.active").find('.item-block'));
                

                
                // let firstSetChild = $(this).closest(".pattern-blocks").find(".owl-item.active").find('.item-block').find(".leftlabels:nth-child(2)");
                // let setObj = {};
                // setObj['exerciseName'] = firstSetChild.find('.exerciseName').val();

                // // console.log()

                // $(this).closest(".pattern-blocks").find(".owl-item.active").find('.item-block').append(firstSetChild);
                // $(this).closest(".pattern-blocks").find(".owl-item.active").find('.item-block').append(strengthPatternSet(index+2));
              }
          }
          
          $('.selectdrop').select2({});
          $('.selectdrop-warmup').select2();
        }
        
    })
    
    $(document).on("click",".exerciseGet",function(){
        
        if($(this).hasClass("active")){
            return false;
        }

        $(".exerciseGet").removeClass("active");
        $(this).addClass("active");
        let exerciseList = "";

        var excrcises = [];
        let exerciseHtml = "";
        let finalList = coachExerciseList;
        
        if($(this).attr("data-type") == "defaultLibrary"){
          finalList = masterExerciseList;
        }

        $.each(finalList, function(key,valueObj){
            if("tags" in valueObj &&  valueObj.tags.length > 0){
              let tags  = valueObj.tags;
              $.each( tags, function( i, val ) {
                if(arr.length > 0){
                  if($.inArray(val.trim(), arr)  != -1){
                        // console.log("key",key);
                          excrcises.push(key); //= key;
                          exerciseHtml += "<li>"+key+"</li>";
                          return false;
                  }
                }else{
                  exerciseHtml += "<li>"+key+"</li>";
                  return false;
                }  
              });
            }
        });
        
        // $(this).closest(".exerciseBoxParent").find(".exerciseList > ul").html(exerciseHtml);




        // if($(this).attr("data-type") == "myLibrary"){
        //     exerciseList = '<ul><li>My Air Squat</li>'+
        //     '<li>My Back Squat</li>'+
        //     '<li>My Front Squat</li>'+
        //     '<li>My Jump Squat</li>'+
        //     '<li>My Sumo Squat</li></ul>';
        // }else{
        //     exerciseList = '<ul><li>Air Squat</li>'+
        //     '<li>Back Squat</li>'+
        //     '<li>Front Squat</li>'+
        //     '<li>Jump Squat</li>'+
        //     '<li>Sumo Squat</li>'+
        //     '<li>Deadlift</li>'+
        //     '<li>Pull-up</li>'+
        //     '<li>Burpee</li>'+
        //     '</ul>';
        // }

        $(this).closest(".Squats-drop-recorded").find(".exerciseList > ul").html(exerciseHtml);

        var searchText = $(this).closest(".leftlabels").find(".exerciseName").val().toLowerCase();
        // console.log("searchText",searchText);

        $(this).closest(".leftlabels").find(".exerciseBox ul > li").each(function(){
            
            var currentLiText = $(this).text().toLowerCase(),
                showCurrentLi = currentLiText.indexOf(searchText) !== -1;
        
            $(this).toggle(showCurrentLi);

        });   
        
        
        // $(this).closest(".leftlabels").find(".exerciseName").trigger("keyup");
        

    })

    // $("body").on("change", '.selectdrop ', function (event) {
    //     // console.log($('.selectdrop').length);
    //     // setTimeout(function(){
    //     $(document).find('.selectdrop').select2();
    //     $(document).find('.selectdrop-warmup').select2();
    //     // },10); 
    
    // }); 

  async function select2Call(){
    $(document).find('.selectdrop').select2();
    $(document).find('.selectdrop-warmup').select2();
  }

  $(document).on("change",".numberofSet",async function(){
    let numberOfSet = $(this).val();
    let patternName = $(this).closest(".form-block").find(".selectPattern").val();
    var patternSetHtml = "";
    // console.log("numberOfSet",numberOfSet);
    // console.log($(this).closest(".pattern-blocks").find(".owl-item.active").find('.item-block'));
    let setLength = $(this).closest(".pattern-blocks").find(".owl-item.active").find('.item-block').find(".leftlabels").length;
    setLength = setLength - 1;
    if(setLength < numberOfSet){
        let gap = numberOfSet - setLength;
        const removeRec = async _ =>{
          for (let index = 0; index < gap; index++) {
              // console.log("patternName",patternName);
              if(patternName == "strength"){
                await $(this).closest(".pattern-blocks").find(".owl-item.active").find('.item-block').append(strengthPatternSet(setLength+index+1));
              }
            }
          }
          await removeRec();
          $(this).closest(".form-block").find(".intensityChange").trigger("change");
    }
    if(setLength > numberOfSet){
      // console.log("in");
      let gap = setLength - numberOfSet;
      // console.log("gap",gap);
      const addRec = async _ => {
        for (let index = 0; index < gap; index++) {
          $(this).closest(".pattern-blocks").find(".owl-item.active").find('.item-block').find(".leftlabels").last().remove();;
        }
      }
      await addRec();
    }
    
    // .append(patternSetHtml);
    
    // await updateCopyFirstToNo();

    await select2Call();

    jQuery(this).closest(".mainSectionStart").find(".copyFirst").trigger("change");
    await updatePreview();
    methods();
    // await deleteExercise();
  })

  // function deleteExercise(){
    jQuery(document).on("click",".deleteExercise",async function(){
      $parent = $(this).closest(".mainSectionStart");
      var indexToRemove = sectionmaster[$(this).closest(".sectionStart").attr('data-id')]["activeSlide"];
      // console.log("indexToRemove",indexToRemove);
      $(this).closest(".owl-carousel").trigger('remove.owl.carousel', [indexToRemove]).trigger('refresh.owl.carousel');

      // console.log($s);
      $parent.find('.item-block').each(function(index, value) {
          $(this).find(".leftlabels:first > .title-top").text(alpha[`${index}`]);
        // console.log(`div${index}: ${this.id}`);
      });

      // jQuery(this).closest(".item").remove();
      await updatePreview();
    })
  // }

  $(document).on("change",".selectPattern", async function(){
    let patternName = $(this).val();
    
    // console.log("sectionmaster",sectionmaster);

    // alert(patternName);
    if(patternName == "strength"){
      var sectionBody = '<div class="item-block">'+
    '                          <div class="leftlabels">'+
    '                            <div class="title-top">'+alpha[(sectionmaster[$(this).closest(".sectionStart").attr('data-id')]['activeSlide'])]+'</div>'+
    '                            <ul class="set-type-list">'+
    '                              <li>Exercise <span class="float-right ml-2">:</span></li>'+
    '                              <li>Quantity <span class="float-right ml-2">:</span></li>'+
    '                              <li>Intensity <span class="float-right ml-2">:</span></li>'+
    '                              <li>1RM <span class="float-right ml-2">:</span></li>'+
    '                              <li>Rest <span class="float-right ml-2">:</span></li>'+
    '                              <li>Notes <span class="float-right ml-2">:</span></li>'+
    '                              <li>Method <span class="float-right ml-2">:</span></li>'+
    '                            </ul>'+
    '                          </div>';
    let totalNumberofSet  = $(this).closest(".exerciseForm").find(".numberofSet ").val();
    for (let numberofSet = 1; numberofSet <= totalNumberofSet; numberofSet++) {
      sectionBody += strengthPatternSet(numberofSet);
    }

    sectionBody += '                        </div>';

    }else{
      $(this).closest(".item").find(".item-block").remove();
    }
    if(sectionBody){
      $(this).closest(".item").append(sectionBody);
    }
    methods();
    

    // await updateCopyFirstToNo();
      await select2Call();
      await updatePreview();
  });

function all_carousel(){ 
  $('.sets-carousel').on('changed.owl.carousel', function(event) 
  {
    var pos = event.relatedTarget.normalize(event.item.index, true); 
    // console.debug("index in original image list is ", pos);   
    // console.log("user in",$(this).html());
    sectionmaster[$(this).closest(".sectionStart").attr('data-id')]["activeSlide"] = pos; 

  });
}
all_carousel();

function methods(){
  $(document).find(".selectMethod").on("change", function () {
    let methodName = $(this).val();
    // console.log("methodName",methodName);
    if(methodName == "tempo"){
      $(this).closest(".methodParent").find(".previousMethod").attr('style','display:none !important');
      $(this).closest(".methodParent").find(".tempoMethod").attr('style','display:flex !important');
    }else if(methodName == "previous"){
      $(this).closest(".methodParent").find(".tempoMethod").attr('style','display:none !important');
      $(this).closest(".methodParent").find(".previousMethod").attr('style','display:flex !important');
    }
    else{
      $(this).closest(".methodParent").find(".tempoMethod").attr('style','display:none !important');
      $(this).closest(".methodParent").find(".previousMethod").attr('style','display:none !important');
    }
  });
}


  $(document).on("click",".addNewExercise", async function(){

    $(this).closest(".sectionStart").find(".collapse-data").show();
    // console.log("start",sectionmaster);
    // console.log("start",$(this).closest(".sectionStart").attr('data-id'));

    sectionmaster[$(this).closest(".sectionStart").attr('data-id')]['count'] += 1; 
    
    var sectionHeader = '<div class="item">'+
              '                        <div class="form-block">'+
              '                          <form class="warm-up-wrapper exerciseForm">'+
              '                            <div class="form-row">'+
              '                              <div class="col-6 col-sm-4">'+
              '                                <label>Pattern</label>'+
              '                                <select class="form-control selectdrop select_section_box selectPattern" tabindex="2">'+
              '                                  <option value="">Select</option>'+
              '                                  <option value="strength">Strength</option>'+
              '                                </select>'+
              '                              </div>'+
              '                              <div class="col-6 col-xl-3 col-sm-2">'+
              '                                <label>No. <span class="text_lowercase_wrap input_txt">of</span> Sets</label>'+
              '                                <select class="form-control selectdrop select_section_box numberofSet">'+
              '                                  <option value="1" selected>1</option>';
              for (let nms = 2; nms <= 20; nms++) {
                sectionHeader += '<option value="'+nms+'">'+nms+'</option>';  
              }
              sectionHeader += 
              '                                </select>'+
              '                              </div>'+
              '                              <div class="col-6 col-xl-2 col-sm-3">'+
              '                                <label>Copy 1st Set</label>'+
              '                                <select class="form-control selectdrop select_section_box copyFirst" data-minimum-results-for-search="Infinity">'+
              '                                  <option value="yes">Yes</option>'+
              '                                  <option value="no" selected>No</option>'+
              '                                </select>'+
              '                              </div>'+
              '                              <div class="col-6 col-xl-1 col-sm-2">'+
              '                                <label>Intensity %</label>'+
              '                                <select class="form-control selectdrop select_section_box intensityChange" data-minimum-results-for-search="Infinity">'+
              
              '                                  <option value="0">Manul</option>'+
              upTo(1,100,1,'')+
              '                                </select>'+
              '                              </div>'+
              '                              <div class="col-6 col-sm-1 delete-wrap">'+
              '                                <div class="delete-btn">'+
              '                                  <a href="#" class="deleteExercise" data-id="'+sectionmaster[$(this).closest(".sectionStart").attr('data-id')]['count']+'">'+
              '                                    <i class="fa fa-trash-o" aria-hidden="true"></i>'+
              '                                  </a>'+
              '                                </div>'+
              '                              </div>'+
              '                            </div>'+
              '                          </form>'+
              '                        </div>'+
              '</div>';

            $(this).closest('.sectionStart').find('.sets-carousel').owlCarousel('add', sectionHeader).owlCarousel('update').trigger('refresh.owl.carousel');
            // $(this).closest(".sectionStart").find(".headerSectionPanel .mainSectionStart").append();
            $(this).closest('.sectionStart').find('.sets-carousel').trigger('to.owl.carousel', 100);
            // updateCopyFirstToNo();
            // $(".selectPattern").val("strength").change();
            // deleteExercise();
            // console.log("sectionmaster",sectionmaster);
            all_carousel();

            $('.selectdrop').select2({});
            $('.selectdrop-warmup').select2();
            await updatePreview();
            methods();
            
  })


  $(document).on("click",".collapse-data-bar",function () {
    $(this).closest(".sectionStart").find(".collapse-data").toggle();
  });

  $(".wramup-wrapper .title-box").click(function (event) {
    event.stopPropagation();
  });
});



$('.progression-carousel').owlCarousel({
  loop: false,
  margin: 20,
  dots: false,
  nav: true,
  items: 5,
  responsive: {
    0: {
      items: 1,
      touchDrag: false,
      mouseDrag: false
    },
    600: {
      items: 2,
      touchDrag: false,
      mouseDrag: false
    },
    1000: {
      items: 3,
    },
    1200: {
      items: 4,
    },
    1300: {
      items: 5,
    }
  }
})

function setsCarousel(){
  $('.sets-carousel').owlCarousel({
  loop: false,
  margin: 20,
  dots: false,
  nav: true,
  items: 1,
  touchDrag: false,
  mouseDrag: false,
  responsive: {
    0: {
      items: 1,
      touchDrag: false,
      mouseDrag: false
    },
    600: {
      items: 1,
      touchDrag: false,
      mouseDrag: false
    },
    900: {
      items: 1,
      touchDrag: false,
      mouseDrag: false
    }
  }
  })
}

setsCarousel();


function formatText(icon) {
  return $('<span><i class="fas ' + $(icon.element).data('icon') + '"></i> ' + icon.text + '</span>');
};

$(document).ready(function () {
  $('.selectdrop').select2();
  $('.select_section_box').select2();

  // loop through option value increment by 1
  var html = '';
  for (var i = 1; i <= 100; i++) {
    html += '<option value="' + i + '">' + i + '</option>';
  }
  $('body').find('.loopOption').append(html);


  var html = '';
  for (var i = 0; i <= 60; i++) {
    html += '<option value="' + i + '">' + i + '</option>';
  }
  $('body').find('.minutes').append(html);
  // end loop through option value increment by 1

  var html = '';
  for (var i = 0; i <= 60; i++) {
    html += '<option value="' + i + '">' + i + '</option>';
  }
  $('body').find('.seconds').append(html);
  // end loop through option value increment by 1

  // loop through increment by 1 till 20, 20-100 increment by 5 and 100-200 by 10
  var k = 1;
  var htmlIncremented = '';
  for (j = 1; j <= 200; j++) {
    if (j < 20) {
      htmlIncremented += '<option value="' + k + '">' + k + '</option>';
      k += 1;
    }

    if (j > 20 && j < 100 && k < 100) {
      htmlIncremented += '<option value="' + k + '">' + k + '</option>';
      k += 5;
    }

    if (j > 100 && j < 200 && k <= 200) {
      htmlIncremented += '<option value="' + k + '">' + k + '</option>';
      k += 10;
    }

    if (k == 210) {
      break;
    }
  }
  $('body').find('.incrementedLoop').append(htmlIncremented);

  // end loop through increment by 1 till 20, 20-100 increment by 5 and 100-200 by 10
  $(".sectionTitleBox").on("click",function(){
    $(this).closest(".sectionStart").find(".sectionTitleBoxList").toggleClass("d-none");
  })

  $(".addata-user-data").on("click", function (params) {
    $(".innerboxcoach-sheet").removeClass(".collapse-data");
  });


});

$(document).on("click",".sectionTitleBox",function(){
  $(this).closest(".sectionStart").find(".sectionTitleBoxList").toggleClass("d-none");
})



// $(document).on("click",function(e){
//   container = $(".wramup-wrapper");

//   if(!container.is(e.target) && container.has(e.target).length === 0){
//     container.find(".wramup-box1").addClass("d-none");
//   }
//   if(!container.is(e.target) && container.has(e.target).length === 0){
//     container.find(".wramup-box2").addClass("d-none");
//   }
// });

// $(".title-box1").on("click", function (params) {
//   $(".wramup-box1").toggleClass("d-none");
// });

// $(".title-box2").on("click", function (params) {
//   $(".wramup-box2").toggleClass("d-none");
// });




// $(document).on("click",function(e){
//   container = $(".addbtn-wrap");

//   if(!container.is(e.target) && container.has(e.target).length === 0){
//     container.find(".innerboxcoach-sheet").addClass("d-block");
//   }
// });


// $(".addbtn-wrap").on("click",function (params) {
//   $(".innerboxcoach-sheet").toggleClass("d-block");    
// }); 

// $(".presetstatic").on("click",function (params) {
//   $(".innerboxcoach-sheet").toggleClass("d-block");    
// }); 



$(".Squats-recorded2").on("click", function (params) {
  $(".Squats-drop-recorded2").toggleClass("d-none");
});

$(".sidemenu-wrap").on("click", function (params) {
  $(".side-nav").toggleClass("d-block");
});


$(".previous-button").on("click", function (params) {
  $("body").toggleClass("previous-data-hide");
});

// $(".close-wrapper").on("click",function (params) {

//   $(".side-nav").addClass("d-none");   
//   $(".side-nav").removeClass("d-block");     

// });

// side bar

function handleMediaQueryChange(mediaQuery) {
  if (window.matchMedia('(max-width: 767px)').matches) {
    // console.log('Media query matched');
    $(".close-wrapper").on("click", function (params) {
      $(".side-nav").addClass("d-none");
      $(".side-nav").removeClass("d-block");
    });
  }
  else {
    $(".side-nav").removeClass("d-none");
  }

}
var mediaQuery = window.matchMedia('(max-width: 557px)');
handleMediaQueryChange(mediaQuery);
mediaQuery.addListener(handleMediaQueryChange);

// edn side bar 

$(".desktop-sidemenu-wrap").on("click", function (params) {
  $("body").toggleClass("hide-sidebar");
});

const time = $('#time');
const placeholder = $('#timeplaceholder');

//init time picker
//http://jdewit.github.io/bootstrap-timepicker/
time.timepicker({
  defaultTime: false,
  minuteStep: 1,
  secondStep: 1,
  showMeridian: false,
  showSeconds: true,
  template: false,
  icons: {
    up: 'x24 fill-p cdc-icon-arrow-down',
    down: 'x24 fill-p cdc-icon-arrow-down'
  }
});
placeholder.timepicker({
  defaultTime: false,
  minuteStep: 1,
  secondStep: 1,
  showMeridian: false,
  showSeconds: true,
  template: false
});

// console.log(placeholder.val())
// console.log(time.val())

placeholder.timepicker().on('changeTime.timepicker', (event) => {
  //   console.log('The time is ' + e.time.value);
  //   console.log('The hour is ' + e.time.hours);
  //   console.log('The minute is ' + e.time.minutes);
  //   console.log('The second is ' + e.time.seconds);

  //   e.time.hours = '';
  //   e.time.minutes = '';
  //   e.time.seconds = '';

  // console.log(event.time)
});

placeholder.timepicker().on('blur', (event) => {
  // console.log(event)
});


$(document).ready(function () {
  $('input.timepicker').timepicker({
    timeFormat: 'mm:ss'
  });
});


$('.multiple_select').select2({
  tags: true,
  placeholder: 'Sub-Sub-Tags',
});

// tree set 


  



  $(".select_section_box").on('select2:open', function (e) {
      $('body').find('span.select2-dropdown--below').addClass('kt_select_pro');
      $('body').find('ul.select2-results__options').addClass('kt_select_pro');
      $('body').find('span.select2-container--open').addClass('kt_select_pro_active');
  });

  $(".select_section_box2").on('select2:open', function (e) {
    $('body').find('span.select2-dropdown--below').addClass('kt_select_pro');
    $('body').find('ul.select2-results__options').addClass('kt_select_pro');
    $('body').find('span.select2-container--open').addClass('kt_select_pro_active2');
});

  

//   var textbox = document.getElementById('datepicker_box')
//     textbox.onclick = function (event) {
//         this.type = 'date';
//         this.focus();
// }

$('.datepicker').datepicker({
  format: "dd/mm/yyyy",
  autoclose: true
});

// back-top

var btn = $("#topup");

$(window).scroll(function () {
if ($(window).scrollTop() > 300) {
  btn.addClass("show");
} else {
  btn.removeClass("show");
}
});

btn.on("click", function (e) {
  e.preventDefault();
  $("html, body").animate({ scrollTop: 0 }, "500");
});


